//Inlets and Outlets
inlets = 3;	//last note pitch, current chord, random factor
outlets = 1;	//note pitch

//Constants
const MINPITCH = 31;
const MAXPITCH = 47;

//Global vars
var lastnote7;
var chord8;
var randomfactor;

var noteprobs = new Array();
var chosenpitch;


//MAIN FUNCTIONS
function msg_int(n)
{
	if(inlet==0)	//first inlet
	{
		lastnote7 = n;
		if(chord8 > 0)	doit();
		
	} else if(inlet==1)	{	//second inlet
		if(n>0)	chord8 = n;
	} else if(inlet==2)	{	//third inlet
		randomfactor = n/100;
	}
}


function doit()
{
	genProbs();
	//printProbs();
	pickNote();
	outlet(0, chosenpitch);
}


function genProbs()
{
	post("\n");
	for(i=MINPITCH; i<MAXPITCH; i++)
	{
		var dp = Math.abs(lastnote7 - i);
		var rangeweight = 1 - Math.floor(dp)/25;
		rangeweight = (randomfactor * Math.random()) + ((1-randomfactor) * rangeweight)
		rangeweight *= 10;
		if(rangeweight < 0)	rangeweight = 0;
		
		var chordweight;
		( getOnTriad(i, chord8) ) ? chordweight = 1 : chordweight = 0;
		chordweight = (randomfactor * Math.random()) + ((1-randomfactor) * chordweight)
		
		var prob = Math.floor(rangeweight * chordweight);
		noteprobs[i-MINPITCH] = prob;
		post(chordweight);
	}
}




function pickNote()
{
	var probs = new Array();
	
	//Make an array of probabilities
	for(i=MINPITCH; i<MAXPITCH; i++)
	{
		for(j=0; j<noteprobs[i-MINPITCH]; j++)
		{
			probs[probs.length] = i;
		}
	}
	
	//Pick one element of prob
	var rand = Math.floor(Math.random() * probs.length);
	
	//Set chosen number
	chosenpitch = probs[rand];
	post("chosenpitch: " + chosenpitch)
}




//HELPER FUNCTIONS
function printProbs()
{
	for(i=MINPITCH; i<MAXPITCH; i++)
	{
		post(noteprobs[i-MINPITCH]);
	}
}


function getOnTriad(p, c)
{
	p %= 7;
	c--;	c %= 7;
	
	var triad = new Array();
	triad[0] = c % 7;
	triad[1] = (c + 2) % 7;
	triad[2] = (c + 4) % 7;
	
	if( (p == triad[0]) || (p == triad[1]) || (p == triad[2]))
	{
		return true;
	} else {
		return false;
	}
}