//gettype.js
//Tom Turton 2008
//
//generate a note type based on current tick and previous note type


//Inlets and Outlets
inlets = 2;	//current tick, ticks per beat
outlets = 1;	//note type

//Constants
const ACCURACY = 3;

//Global vars
var lasttype = -1;
var type = -1;
var tick = -1;
var numticks = -1;

var prob_off = 10;
var prob_normal = 0;
var prob_lean = 0;
var prob_pass = 0;


//Functions
function msg_int(n)
{
	if(inlet==0)
	{
		tick = n;
		if(numticks>0)
		{
			calculate();
		}
	} else {	//second inlet
		numticks = n;
	}
}


function calculate()
{
	//prepare
	r = tick % (numticks / ACCURACY);
	//post("r=" + r + "\n");
	
	if(r==0)	// in scope
	{
		//calculate
		switch(lasttype)	//what was the last note type?
		{
		case 0:	//no note
			switch(r)
			{
			case 0:	//first semiquaver
				prob_off		= 1;
				prob_normal	= 5;
				prob_lean		= 3;
				prob_pass	= 1;
				break;
			case 1:	//second semiquaver
				prob_off		= 5;
				prob_normal	= 2;
				prob_lean		= 1;
				prob_pass	= 2;
				break;
			case 2:	//third semiquaver
				prob_off		= 3;
				prob_normal	= 4;
				prob_lean		= 1;
				prob_pass	= 2;
				break;
			case 3:	//forth semiquaver
				prob_off		= 3;
				prob_normal	= 1;
				prob_lean		= 2;
				prob_pass	= 4;
				break;
			}
			break;
		case 1:	//normal note
			switch(r)
			{
			case 0:	//first semiquaver
				prob_off		= 1;
				prob_normal	= 5;
				prob_lean		= 3;
				prob_pass	= 1;
				break;
			case 1:	//second semiquaver
				prob_off		= 5;
				prob_normal	= 2;
				prob_lean		= 1;
				prob_pass	= 2;
				break;
			case 2:	//third semiquaver
				prob_off		= 3;
				prob_normal	= 4;
				prob_lean		= 1;
				prob_pass	= 2;
				break;
			case 3:	//forth semiquaver
				prob_off		= 3;
				prob_normal	= 1;
				prob_lean		= 2;
				prob_pass	= 4;
				break;
			}
			break;
		case 2:	//leaning note
			switch(r)
			{
			case 0:	//first semiquaver
				prob_off		= 0;
				prob_normal	= 10;
				prob_lean		= 0;
				prob_pass	= 0;
				break;
			case 1:	//second semiquaver
				prob_off		= 10;
				prob_normal	= 0;
				prob_lean		= 0;
				prob_pass	= 0;
				break;
			case 2:	//third semiquaver
				prob_off		= 10;
				prob_normal	= 0;
				prob_lean		= 0;
				prob_pass	= 0;
				break;
			case 3:	//forth semiquaver
				prob_off		= 10;
				prob_normal	= 0;
				prob_lean		= 0;
				prob_pass	= 0;
				break;
			}
			break;
		case 3:	//passing note
			switch(r)
			{
			case 0:	//first semiquaver
				prob_off		= 0;
				prob_normal	= 10;
				prob_lean		= 0;
				prob_pass	= 0;
				break;
			case 1:	//second semiquaver
				prob_off		= 10;
				prob_normal	= 0;
				prob_lean		= 0;
				prob_pass	= 0;
				break;
			case 2:	//third semiquaver
				prob_off		= 10;
				prob_normal	= 0;
				prob_lean		= 0;
				prob_pass	= 0;
				break;
			case 3:	//forth semiquaver
				prob_off		= 10;
				prob_normal	= 0;
				prob_lean		= 0;
				prob_pass	= 0;
				break;
			}
			break;
		}
		
		var diceroll = Math.floor(Math.random() * 10);
		var res = 0;
		
		res += prob_off;
		
		if(res > diceroll)
		{
			type = 0;	//no note
		} else { 
			res += prob_normal;
			if(res > diceroll)
			{
				type = 1;	//normal note
			} else {
				res += prob_lean;
				if(res > diceroll)
				{
					type = 2;	//lean note
				} else {
					res += prob_pass;
					if(res > diceroll)
					{
						type = 3;	//passing note
					}
				}
			}
		}
		
		
		//type = tick + prev;
		
	} else {	// out of scope
		type = 0;
	}
	
	//return
	outlet(0, type);
	
	//clean up
	lasttype = type;
	type = -1;
	tick = -1;
}